summaryrefslogtreecommitdiff
path: root/tests/du/hard-link
diff options
context:
space:
mode:
Diffstat (limited to 'tests/du/hard-link')
-rwxr-xr-xtests/du/hard-link71
1 files changed, 71 insertions, 0 deletions
diff --git a/tests/du/hard-link b/tests/du/hard-link
new file mode 100755
index 0000000..1e7a5f9
--- /dev/null
+++ b/tests/du/hard-link
@@ -0,0 +1,71 @@
+#!/bin/sh
+# Ensure that hard-linked files are counted (and listed) only once.
+# Likewise for excluded directories.
+# Ensure that hard links _are_ listed twice when using --count-links.
+
+# Copyright (C) 2003, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ du --version
+fi
+
+. $srcdir/../envvar-check
+. $srcdir/../lang-default
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+mkdir -p dir/sub
+( cd dir && { echo non-empty > f1; ln f1 f2; echo non-empty > sub/F; } )
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# Note that for this first test, we transform f1 or f2
+# (whichever name we find first) to f_. That is necessary because,
+# depending on the type of file system, du could encounter either of those
+# two hard-linked files first, thus listing that one and not the other.
+du -a --exclude=sub dir \
+ | sed 's/^[0-9][0-9]* //' | sed 's/f[12]/f_/' > out || fail=1
+echo === >> out
+du -a --exclude=sub --count-links dir \
+ | sed 's/^[0-9][0-9]* //' | sort -r >> out || fail=1
+cat <<\EOF > exp
+dir/f_
+dir
+===
+dir/f2
+dir/f1
+dir
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff -u out exp 2> /dev/null
+
+(exit $fail); exit $fail